#global snaprel -patch1
%global snaprel %{nil}

%define _build_id_links none
%define debug_package %{nil}
%undefine _hardened_build

%global hdf5version 1.10.6
%global hdf5numversion %( echo %{hdf5version} | awk -F. '{printf("%01d%02d%02d",$1,$2,$3)}' )

# compiler for which we are doing this
%{!?compiler: %global compiler gcc}

# intel defaults
%{!?compilermajor: %global compilermajor 16}
%{!?compilerminor: %global compilerminor 0}
%{!?openmpiversion: %global openmpiversion 4.0.4}
%{!?intelmpiversion: %global intelmpiversion 2019.7}
%global openmpinumversion %( printf "%02d%02d%02d" `echo %{openmpiversion} | cut -d. -f1,2,3 --output-delimiter=" "` )
%global compilerrname %{compiler}%{compilerversionnum}

%bcond_without tests

%global with_mpich2 0
%global with_openmpi 1
%bcond_with mpt
%ifarch x86_64
%bcond_without impi
%else
%bcond_with impi
%endif
%if 0%{?rhel}
%ifarch ppc64
# No mpich2 on ppc64 in EL
%global with_mpich2 0
%endif
%endif

%if %{with_mpich2}
%global mpi_list mpich2
%endif
%if %{with_openmpi}
%global mpi_list %{?mpi_list} openmpi
%endif
%if %{with mpt}
%global mpi_list %{?mpi_list} mpt
%endif
%if %{with impi}
%global mpi_list %{?mpi_list} intel-mpi
%endif

# modules defaults
%global modulefile_path_top /usr/local/share/Modules/modulefiles/hdf5
%global intelmpimodule intel-mpi/%{compiler}


%ifarch %{ix86}
%global bits 32
%else
%global bits 64
%endif

# deployment plan:
# top dir /usr/local/hdf5
#                        /gcc/1.8.8
#			 /gcc/openmpi-1.5.4/1.8.8
#			 /gcc/mpt/1.8.8
#			 /gcc/intel-mpi/1.8.8
#                        /intel-12.1/1.8.8
#                        /intel-12.1/openmpi-1.5.4/1.8.8
#                        /intel-12.1/mpt/1.8.8
#                        /intel-12.1/intel-mpi/1.8.8

# now, depending on the compiler we need different things - place them all here for eacy access/changing
#
# GCC Compiler
%if "%{compiler}" == "gcc"
%global compilerruntime BuildRequires: gcc-gfortran
%global compilerruntimeopenmpi BuildRequires: openmpi-gcc-devel = %{openmpiversion} \
Requires: openmpi-gcc-runtime >= %{openmpiversion}
%global compilerruntimempt BuildRequires: sgi-mpt >= 2.05 \
Requires: sgi-mpt >= 2.05
%global compilerruntimeimpi BuildRequires: intel-mpi-modules-devel = %{intelmpiversion}, intel-mpi-modules-gcc = %{intelmpiversion} \
Requires: intel-mpi-modules-gcc >= %{intelmpiversion}
%global compilerdevel Requires: gcc-gfortran
%global compilerdevelopenmpi Requires: gcc-gfortran \
Requires: openmpi-gcc-devel >= %{openmpiversion}
%global compilerdevelmpt Requires: gcc-gfortran \
Requires: sgi-mpt >= 2.05
%global compilerdevelimpi Requires: gcc-gfortran \
Requires: intel-mpi-modules-devel >= %{intelmpiversion}, intel-mpi-modules-gcc >= %{intelmpiversion}
%global localdir /usr/local/hdf5/gcc/%{version}
%global localdiropenmpi /usr/local/hdf5/gcc/openmpi-%{openmpiversion}/%{version}
%global localdirmpt /usr/local/hdf5/gcc/mpt/%{version}
%global localdirimpi /usr/local/hdf5/gcc/intel-mpi/%{version}
%global modulempt mpt
# do nothing special for gcc for build prep
%global compilerbuildprep export FFLAGS="-O3" FCFLAGS="-O3"
# which mpif* wrapper to use
%global mpif90 mpif90
# no alias
%global modulefile_compiler_alias %{nil}
%global compilershort gcc
%global compilerlong gcc
%global compilerversionnum 446
%global compilerrname gcc
#global optflags -O0 -pipe -Wall
%endif
#
# Devtoolset compiler
%if %( echo %{compiler} | cut -d- -f1 ) == "devtoolset"
%global compilerrname %{compiler}
%global compilerruntime BuildRequires: %{compiler}-build %{compiler}-toolchain
%global compilerruntimeopenmpi BuildRequires: openmpi-%{compilerrname}-devel = %{openmpiversion} \
Requires: openmpi-%{compilerrname}-runtime >= %{openmpiversion}
%global compilerruntimempt BuildRequires: sgi-mpt >= 2.05 \
Requires: sgi-mpt >= 2.05
%global compilerruntimeimpi BuildRequires: intel-mpi-modules-devel = %{intelmpiversion}, intel-mpi-modules-gcc = %{intelmpiversion} \
Requires: intel-mpi-modules-gcc >= %{intelmpiversion}
%global compilerdevel Requires: %{compiler}-build %{compiler}-toolchain
%global compilerdevelopenmpi Requires: %{compiler}-build %{compiler}-toolchain \
Requires: openmpi-%{compilerrname}-devel >= %{openmpiversion}
%global compilerdevelmpt Requires: %{compiler}-build %{compiler}-toolchain \
Requires: sgi-mpt >= 2.05
%global compilerdevelimpi Requires: %{compiler}-build %{compiler}-toolchain \
Requires: intel-mpi-modules-devel >= %{intelmpiversion}, intel-mpi-modules-gcc >= %{intelmpiversion}
%global localdir /usr/local/hdf5/%{compiler}/%{version}
%global localdiropenmpi /usr/local/hdf5/%{compiler}/openmpi-%{openmpiversion}/%{version}
%global localdirmpt /usr/local/hdf5/%{compiler}/mpt/%{version}
%global localdirimpi /usr/local/hdf5/%{compiler}/intel-mpi/%{version}
%global modulempt mpt
%global compilerbuildprep export FFLAGS="-O3" FCFLAGS="-O3"; . /opt/rh/%{compiler}/enable
%global mpif90 mpif90
# no alias
%global modulefile_compiler_alias %{nil}
%global compilershort %{compiler}
%global compilerlong %{compiler}
%global compilerversionnum 481
%global optflags -O3 -pipe -Wall
%global intelmpimodule intel-mpi/gcc
%endif
#
# Intel compiler
%if "%{compiler}" == "intel"
# these two are used to decide which version of intel we will be using to build it all
# and which version we will be providing
%{!?intelminrelease: %global intelminrelease 1}
%global compilerversion %{compilermajor}.%{compilerminor}
%global compilerversionnum %{compilermajor}%{compilerminor}
%global compilerruntime Requires: intel-compiler%{compilermajor}-%{bits}-default-modules >= %{compilerversion}-%{intelminrelease} \
BuildRequires: intel-compiler%{compilermajor}-%{bits}-default-modules-devel >= %{compilerversion}-%{intelminrelease} intel-compiler%{compilermajor}-%{bits}-default-modules-devel = %{compilerversion} intel-compiler-default-%{compilerversionnum} \
Obsoletes: hdf5-%{hdf5numversion}-%{compiler}
%global compilerruntimeopenmpi BuildRequires: openmpi-intel%{compilerversionnum}-devel = %{openmpiversion} \
Requires: openmpi-intel%{compilerversionnum}-runtime >= %{openmpiversion} \
Obsoletes: hdf5-%{hdf5numversion}-%{compiler}-openmpi%{openmpinumversion}
%global compilerruntimempt BuildRequires: sgi-mpt-intel%{compilerversionnum}-devel >= 2.05 \
Requires: sgi-mpt-intel%{compilerversionnum} >= 2.05
%global compilerruntimeimpi BuildRequires: intel-compiler%{compilermajor}-%{bits}-default-modules-devel >= %{compilerversion}-%{intelminrelease}, intel-mpi-modules-devel = %{intelmpiversion}, intel-mpi-modules-intel = %{intelmpiversion} \
Requires: intel-mpi-modules-intel >= %{intelmpiversion}, intel-compiler%{compilermajor}-%{bits}-default-modules >= %{compilerversion}-%{intelminrelease}
%global compilerdevel Requires: intel-compiler%{compilermajor}-%{bits}-default-modules-devel >= %{compilerversion}-%{intelminrelease} \
Obsoletes: hdf5-%{hdf5numversion}-%{compiler}-devel
%global compilerdevelopenmpi Requires: openmpi-intel%{compilerversionnum}-devel >= %{openmpiversion} \
Obsoletes: hdf5-%{hdf5numversion}-%{compiler}-openmpi%{openmpinumversion}-devel
%global compilerdevelmpt Requires: sgi-mpt-intel%{compilerversionnum}-devel >= 2.05
%global compilerdevelimpi Requires: intel-compiler%{compilermajor}-%{bits}-default-modules-devel >= %{compilerversion}-%{intelminrelease}, intel-mpi-modules-devel >= %{intelmpiversion}, intel-mpi-modules-intel >= %{intelmpiversion}
%global localdir /usr/local/hdf5/intel-%{compilerversion}/%{version}
%global localdiropenmpi /usr/local/hdf5/intel-%{compilerversion}/openmpi-%{openmpiversion}/%{version}
%global localdirmpt /usr/local/hdf5/intel-%{compilerversion}/mpt/%{version}
%global localdirimpi /usr/local/hdf5/intel-%{compilerversion}/intel-mpi/%{version}
%global modulempt mpt/intel-%{compilerversion}
# for intel we need to just specify our compilers
%global compilerbuildprep export CC=icc CXX=icpc F9X=ifort LDFLAGS="-Wl,--build-id" FFLAGS="-O3" FCFLAGS="-O3"; module load intel
%global mpif90 mpiifort
# the following is used in above
%global compilershort intel-%{compilermajor}
%global compilerlong intel-%{compilerversion}
%global optflags -O3
%endif

# Intel compiler
%if "%{compiler}" == "pgi"
%undefine _missing_build_ids_terminate_build
%global compilerversion %{compilermajor}.%{compilerminor}
%global compilerversionnum %{compilermajor}%{compilerminor}
%global compilerruntime Requires: pgi-workstation-libs >= %{compilerversion}\
BuildRequires: pgi-workstation = %{compilerversion}
%global compilerruntimeopenmpi BuildRequires: openmpi-pgi%{compilerversionnum}-devel = %{openmpiversion} \
Requires: openmpi-pgi%{compilerversionnum}-runtime >= %{openmpiversion}
%global compilerruntimempt BuildRequires: sgi-mpt-pgi%{compilerversionnum}-devel >= 2.05 \
Requires: sgi-mpt-pgi%{compilerversionnum} >= 2.05
%global compilerruntimeimpi BuildRequires: pgi-workstation = %{compilerversion}, intel-mpi-modules-devel = %{intelmpiversion}, intel-mpi-modules-pgi = %{intelmpiversion} \
Requires: intel-mpi-modules-pgi >= %{intelmpiversion}, pgi-workstation-libs >= %{compilerversion}
%global compilerdevel Requires: pgi-workstation = %{compilerversion}
%global compilerdevelopenmpi Requires: openmpi-pgi%{compilerversionnum}-devel >= %{openmpiversion}
%global compilerdevelmpt Requires: sgi-mpt-pgi%{compilerversionnum}-devel >= 2.05
%global compilerdevelimpi Requires: pgi-workstation = %{compilerversion}, intel-mpi-modules-devel >= %{intelmpiversion}, intel-mpi-modules-pgi >= %{intelmpiversion}
%global localdir /usr/local/hdf5/pgi-%{compilerversion}/%{version}
%global localdiropenmpi /usr/local/hdf5/pgi-%{compilerversion}/openmpi-%{openmpiversion}/%{version}
%global localdirmpt /usr/local/hdf5/pgi-%{compilerversion}/mpt/%{version}
%global localdirimpi /usr/local/hdf5/pgi-%{compilerversion}/intel-mpi/%{version}
%global modulempt mpt/pgi-%{compilerversion}
%global __global_ldflags %{nil}
%global compilerbuildprep export CFLAGS="-fPIC" FFLAGS="-O3 -fPIC" FCFLAGS="-O3 -fPIC" LDFLAGS=" "; module load pgi
%global mpif90 mpiifort
# the following is used in above
%global compilershort pgi-%{compilermajor}
%global compilerlong pgi-%{compilerversion}
%global optflags -O3
%endif

# where modules really go
%global modulefile_path %{modulefile_path_top}/%{compilerlong}
# alias to make sure that module load hdf5/gcc does not load hdf5/gcc/openmpi
# also it makes sure that module load hdf5/intel and hdf5/intel-12 work
%global modulefile_compiler_alias %{modulefile_path_top}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-%{hdf5numversion}

# NOTE:  Try not to realease new versions to released versions of Fedora
# You need to recompile all users of HDF5 for each version change
Name: hdf5-%{hdf5numversion}-%{compilerrname}
Version: %{hdf5version}
Release: 26%{?dist}
Summary: A general purpose library and file format for storing scientific data
License: BSD
Group: System Environment/Libraries
URL: http://www.hdfgroup.org/HDF5/
Source0: http://www.hdfgroup.org/ftp/HDF5/current/src/hdf5-%{version}%{?snaprel}.tar.bz2
Source1: h5comp
Patch0: hdf5-LD_LIBRARY_PATH.patch
Patch1: hdf5-1.8.8-tstlite.patch
Patch10: hdf5-fixpic.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: krb5-devel, openssl-devel, zlib-devel, time
%if %{rhel} > 7
BuildRequires: libaec-devel
%else
BuildRequires: szip-devel
%endif
BuildRequires: hostname
Provides: hdf5-%{hdf5numversion}-%{compiler} = %{version}-%{release}
Requires: environment-modules
%{compilerruntime}

%description
HDF5 is a general purpose library and file format for storing scientific data.
HDF5 can store two primary objects: datasets and groups. A dataset is
essentially a multidimensional array of data elements, and a group is a
structure for organizing objects in an HDF5 file. Using these two basic
objects, one can create and store almost any kind of scientific data
structure, such as images, arrays of vectors, and structured and unstructured
grids. You can also mix and match them in HDF5 files according to your needs.

%package devel
Summary: HDF5 development files
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: zlib-devel
%if %{rhel} > 7
Requires: libaec-devel
%else
Requires: szip-devel
%endif
%{compilerdevel}
Provides: hdf5-%{hdf5numversion}-%{compiler}-devel = %{version}-%{release}

%description devel
HDF5 development headers and libraries.

%package static
Summary: HDF5 static libraries
Group: Development/Libraries
Requires: %{name}-devel = %{version}-%{release}
Provides: hdf5-%{hdf5numversion}-%{compiler}-static = %{version}-%{release}

%description static
HDF5 static libraries.


%if %{with_mpich2}
%package mpich2
Summary: HDF5 mpich2 libraries
Group: Development/Libraries
Requires: mpich2
Requires: environment-modules
BuildRequires: mpich2-devel
Provides: hdf5-%{hdf5numversion}-%{compiler}-mpich2 = %{version}-%{release}

%description mpich2
HDF5 parallel mpich2 libraries

%package mpich2-devel
Summary: HDF5 mpich2 development files
Group: Development/Libraries
Requires: %{name}-mpich2%{?_isa} = %{version}-%{release}
Requires: mpich2
Provides: hdf5-%{hdf5numversion}-%{compiler}-mpich2-devel = %{version}-%{release}

%description mpich2-devel
HDF5 parallel mpich2 development files

%package mpich2-static
Summary: HDF5 mpich2 static libraries
Group: Development/Libraries
Requires: %{name}-mpich2-devel%{?_isa} = %{version}-%{release}
Provides: hdf5-%{hdf5numversion}-%{compiler}-mpich2-static = %{version}-%{release}

%description mpich2-static
HDF5 parallel mpich2 static libraries
%endif


%if %{with_openmpi}
%package openmpi%{openmpinumversion}
Summary: HDF5 openmpi libraries
Group: Development/Libraries
Requires: environment-modules
Obsoletes: %{name}-openmpi
Provides: hdf5-openmpi = %{version}-%{openmpiversion}.%{release}
Provides: openmpi-hdf5 = %{openmpiversion}-%{version}.%{release}
%{compilerruntimeopenmpi}
Provides: hdf5-%{hdf5numversion}-%{compiler}-openmpi%{openmpinumversion} = %{version}-%{release}

%description openmpi%{openmpinumversion}
HDF5 parallel openmpi libraries

%package openmpi%{openmpinumversion}-devel
Summary: HDF5 openmpi development files
Group: Development/Libraries
Requires: %{name}-openmpi%{openmpinumversion}%{?_isa} = %{version}-%{release}
Obsoletes: %{name}-openmpi-devel
Provides: hdf5-openmpi-devel = %{version}-%{openmpiversion}.%{release}
Provides: openmpi-hdf5-devel = %{openmpiversion}-%{version}.%{release}
Provides: hdf5-%{hdf5numversion}-%{compiler}-openmpi%{openmpinumversion}-devel = %{version}-%{release}
%{compilerdevelopenmpi}

%description openmpi%{openmpinumversion}-devel
HDF5 parallel openmpi development files

%package openmpi%{openmpinumversion}-static
Summary: HDF5 openmpi static libraries
Group: Development/Libraries
Requires: %{name}-openmpi%{openmpinumversion}-devel%{?_isa} = %{version}-%{release}
Obsoletes: %{name}-openmpi-static
Provides: hdf5-openmpi-static = %{version}-%{openmpiversion}.%{release}
Provides: openmpi-hdf5-static = %{openmpiversion}-%{version}.%{release}
Provides: hdf5-%{hdf5numversion}-%{compiler}-openmpi%{openmpinumversion}-static = %{version}-%{release}

%description openmpi%{openmpinumversion}-static
HDF5 parallel openmpi static libraries
%endif

%if %{with mpt}
%package mpt
Summary: HDF5 mpt libraries
Group: Development/Libraries
Requires: environment-modules
Provides: hdf5-mpt = %{version}
Provides: mpt-hdf5 = %{version}.%{release}
%{compilerruntimempt}
Provides: hdf5-%{hdf5numversion}-%{compiler}-mpt = %{version}-%{release}

%description mpt
HDF5 parallel mpt libraries

%package mpt-devel
Summary: HDF5 mpt development files
Group: Development/Libraries
Requires: %{name}-mpt%{?_isa} = %{version}-%{release}
Provides: hdf5-mpt-devel = %{version}-%{release}
Provides: mpt-hdf5-devel = %{version}.%{release}
Provides: hdf5-%{hdf5numversion}-%{compiler}-mpt-devel = %{version}-%{release}
%{compilerdevelmpt}

%description mpt-devel
HDF5 parallel mpt development files

%package mpt-static
Summary: HDF5 mpt static libraries
Group: Development/Libraries
Requires: %{name}-mpt-devel%{?_isa} = %{version}-%{release}
Provides: hdf5-mpt-static = %{version}-%{release}
Provides: mpt-hdf5-static = %{version}.%{release}
Provides: hdf5-%{hdf5numversion}-%{compiler}-mpt-static = %{version}-%{release}

%description mpt-static
HDF5 parallel mpt static libraries
%endif

%if %{with impi}
%package impi
Summary: HDF5 intel mpi libraries
Group: Development/Libraries
Requires: environment-modules
Provides: hdf5-impi = %{version}
Provides: impi-hdf5 = %{version}.%{release}
%{compilerruntimeimpi}
Provides: hdf5-%{hdf5numversion}-%{compiler}-impi = %{version}-%{release}

%description impi
HDF5 parallel intel mpi libraries

%package impi-devel
Summary: HDF5 impi development files
Group: Development/Libraries
Requires: %{name}-impi%{?_isa} = %{version}-%{release}
Provides: hdf5-impi-devel = %{version}-%{release}
Provides: impi-hdf5-devel = %{version}.%{release}
Provides: hdf5-%{hdf5numversion}-%{compiler}-impi-devel = %{version}-%{release}
%{compilerdevelimpi}

%description impi-devel
HDF5 parallel intel mpi development files

%package impi-static
Summary: HDF5 impi static libraries
Group: Development/Libraries
Requires: %{name}-impi-devel%{?_isa} = %{version}-%{release}
Provides: hdf5-impi-static = %{version}-%{release}
Provides: impi-hdf5-static = %{version}.%{release}
Provides: hdf5-%{hdf5numversion}-%{compiler}-impi-static = %{version}-%{release}

%description impi-static
HDF5 parallel intel mpi static libraries
%endif

%prep
%setup -q -n hdf5-%{version}%{?snaprel}
%patch0 -p1 -b .LD_LIBRARY_PATH
%ifarch ppc64 s390x x86_64
# the tstlite test fails with "stack smashing detected" on these arches
#patch1 -p1 -b .tstlite
%endif
#This should be fixed in 1.8.7
find \( -name '*.[ch]*' -o -name '*.f90' -o -name '*.txt' \) -exec chmod -x {} +
%if "%{compiler}" == "intel"
%patch10 -p1 -b .fixpic
%endif

%build
. /etc/profile.d/modules.sh
export MODULEPATH=$MODULEPATH:/usr/local/share/Modules/modulefiles:/opt/share/Modules/modulefiles

# Kill the stack protection and fortify source stuff...it slows things down and here we only care about speed
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/-Wp,-D_FORTIFY_SOURCE=.//' -e 's/-fstack-protector-strong//' -e 's/-fstack-protector//' -e 's/-fstack-clash-protection//'`
%if !%{with debug}
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/-g//'`
%endif

CFLAGS="%{?cflags:%{cflags}}%{!?cflags:$RPM_OPT_FLAGS}"
CXXFLAGS="%{?cxxflags:%{cxxflags}}%{!?cxxflags:$RPM_OPT_FLAGS}"
FCFLAGS="%{?fcflags:%{fcflags}}%{!?fcflags:$RPM_OPT_FLAGS} -I%{_fmoddir}"
FFLAGS="%{?fcflags:%{fcflags}}%{!?fcflags:$RPM_OPT_FLAGS} -I%{_fmoddir}"

#Do out of tree builds
%global _configure ../configure
#Common configure options
%global configure_opts \\\
  --disable-dependency-tracking \\\
  --enable-fortran \\\
  --enable-hl \\\
  --enable-shared \\\
  --disable-silent-rules \\\
  --disable-silent-rules \\\
  --with-szlib \\\
%{nil}
# --enable-cxx and --enable-parallel flags are incompatible
# --with-mpe=DIR          Use MPE instrumentation [default=no]
# --enable-cxx/fortran/parallel and --enable-threadsafe flags are incompatible

#Serial build
export CC=gcc
export CXX=g++
export F9X=gfortran
%{compilerbuildprep}
mkdir build
pushd build
ln -s ../configure .
%configure \
  %{configure_opts} \
  --libdir=%{localdir}/%{_lib} \
  --bindir=%{localdir}/bin \
  --sbindir=%{localdir}/sbin \
  --includedir=%{localdir}/include \
  --datadir=%{localdir}/share \
  --datarootdir=%{localdir}/share \
  --mandir=%{localdir}/share/man \
  --exec-prefix=%{localdir} \
  --enable-cxx
make
module purge
popd

#MPI builds
buildone() {
export CC=mpicc
export CXX=mpicxx
export F9X=$3
export FC=$3
mkdir $1
pushd $1
  ln -s ../configure .
  %configure \
    %{configure_opts} \
    --enable-parallel \
    --libdir=$2/%{_lib} \
    --bindir=$2/bin \
    --sbindir=$2/sbin \
    --includedir=$2/include \
    --datadir=$2/share \
    --datarootdir=$2/share \
    --mandir=$2/share/man \
    --exec-prefix=$2
  make
  module purge
popd
}
%if %{with_openmpi}
  %{compilerbuildprep}
  module load openmpi
  buildone openmpi %{localdiropenmpi} mpif90
%endif
%if %{with mpt}
  %{compilerbuildprep}
  module load %{modulempt}
  buildone mpt %{localdirmpt} mpif90
%endif
%if %{with impi}
  %{compilerbuildprep}
  module load %{intelmpimodule}
  buildone intel-mpi %{localdirimpi} %{mpif90}
%endif

%install
rm -rf $RPM_BUILD_ROOT

. /etc/profile.d/modules.sh
export MODULEPATH=$MODULEPATH:/usr/local/share/Modules/modulefiles:/opt/share/Modules/modulefiles

# Kill the stack protection and fortify source stuff...it slows things down and here we only care about speed
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/-Wp,-D_FORTIFY_SOURCE=.//' -e 's/-fstack-protector-strong//' -e 's/-fstack-protector//' -e 's/-fstack-clash-protection//'`
%if !%{with debug}
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/-g//'`
%endif

CFLAGS="%{?cflags:%{cflags}}%{!?cflags:$RPM_OPT_FLAGS}"
CXXFLAGS="%{?cxxflags:%{cxxflags}}%{!?cxxflags:$RPM_OPT_FLAGS}"
FCFLAGS="%{?fcflags:%{fcflags}}%{!?fcflags:$RPM_OPT_FLAGS} -I%{_fmoddir}"
FFLAGS="%{?fcflags:%{fcflags}}%{!?fcflags:$RPM_OPT_FLAGS} -I%{_fmoddir}"

#Serial build
export CC=gcc
export CXX=g++
export F9X=gfortran
%{compilerbuildprep}
make -C build install DESTDIR=${RPM_BUILD_ROOT}
rm $RPM_BUILD_ROOT/%{localdir}/%{_lib}/*.la
module purge
%if %{with_openmpi}
  %{compilerbuildprep}
  module load openmpi
  make -C openmpi install DESTDIR=${RPM_BUILD_ROOT}
  rm $RPM_BUILD_ROOT/%{localdiropenmpi}/%{_lib}/*.la
  module purge
%endif
%if %{with mpt}
  %{compilerbuildprep}
  module load %{modulempt}
  make -C mpt install DESTDIR=${RPM_BUILD_ROOT}
  rm $RPM_BUILD_ROOT/%{localdirmpt}/%{_lib}/*.la
  module purge
%endif
%if %{with impi}
  %{compilerbuildprep}
  module load %{intelmpimodule}
  make -C intel-mpi install DESTDIR=${RPM_BUILD_ROOT}
  rm $RPM_BUILD_ROOT/%{localdirimpi}/%{_lib}/*.la
  module purge
%endif

#Fortran modules
#mkdir -p ${RPM_BUILD_ROOT}%{_fmoddir}
#mv ${RPM_BUILD_ROOT}%{_includedir}/*.mod ${RPM_BUILD_ROOT}%{_fmoddir}

#Fixup headers and scripts for multiarch
#%ifarch x86_64 ppc64 ia64 s390x sparc64 alpha
#sed -i -e s/H5pubconf.h/H5pubconf-64.h/ ${RPM_BUILD_ROOT}%{_includedir}/H5public.h
#mv ${RPM_BUILD_ROOT}%{_includedir}/H5pubconf.h \
#   ${RPM_BUILD_ROOT}%{_includedir}/H5pubconf-64.h
#for x in h5c++ h5cc h5fc
#do
#  mv ${RPM_BUILD_ROOT}%{_bindir}/${x} \
#     ${RPM_BUILD_ROOT}%{_bindir}/${x}-64
#  install -m 0755 %SOURCE1 ${RPM_BUILD_ROOT}%{_bindir}/${x}
#done
#%else
#sed -i -e s/H5pubconf.h/H5pubconf-32.h/ ${RPM_BUILD_ROOT}%{_includedir}/H5public.h
#mv ${RPM_BUILD_ROOT}%{_includedir}/H5pubconf.h \
#   ${RPM_BUILD_ROOT}%{_includedir}/H5pubconf-32.h
#for x in h5c++ h5cc h5fc
#do
#  mv ${RPM_BUILD_ROOT}%{_bindir}/${x} \
#     ${RPM_BUILD_ROOT}%{_bindir}/${x}-32
#  install -m 0755 %SOURCE1 ${RPM_BUILD_ROOT}%{_bindir}/${x}
#done
#%endif

for i in $RPM_BUILD_ROOT/%{localdir} $RPM_BUILD_ROOT/%{localdiropenmpi}/ $RPM_BUILD_ROOT/%{localdirmpt} $RPM_BUILD_ROOT/%{localdirimpi}; do
	#Fixup example permissions
	[ -d $i ] && find $i \( -name '*.[ch]*' -o -name '*.f90' \) -exec chmod -x {} +
	# hack to make gfortran work transparently, still to see what it does for intel
	if [ -d ${i}/%{_lib} ]; then
		pushd $i/%{_lib}
		ln -s ../include finclude
		popd
	fi
done

mkdir -p ${RPM_BUILD_ROOT}%{modulefile_path}
# first the alias
cat <<ENDMODULEFILETRICK >$RPM_BUILD_ROOT/%{modulefile_compiler_alias}
#%Module
module-alias hdf5/%{compilerlong} hdf5/%{compilerlong}/%{version}
ENDMODULEFILETRICK
%if "%{compiler}" != "%{compilershort}"
echo "module-alias hdf5/%{compilershort} hdf5/%{compilerlong}/%{version}" >> $RPM_BUILD_ROOT/%{modulefile_compiler_alias}
echo "module-alias hdf5/%{compilershort}/%{version} hdf5/%{compilerlong}/%{version}" >> $RPM_BUILD_ROOT/%{modulefile_compiler_alias}
# we also need it in %{compilershort} subdir
mkdir -p $RPM_BUILD_ROOT/%{modulefile_path_top}/%{compilershort}
pushd $RPM_BUILD_ROOT/%{modulefile_path_top}/%{compilershort}
ln -s ../.modulerc-%{compiler}-%{bits}* .
popd
%endif
%if "%{compiler}" != "%{compilerlong}"
echo "module-alias hdf5/%{compiler} hdf5/%{compilerlong}/%{version}" >> $RPM_BUILD_ROOT/%{modulefile_compiler_alias}
echo "module-alias hdf5/%{compiler}/%{version} hdf5/%{compilerlong}/%{version}" >> $RPM_BUILD_ROOT/%{modulefile_compiler_alias}
# we also need it in %{compiler} subdir
mkdir -p $RPM_BUILD_ROOT/%{modulefile_path_top}/%{compiler}
pushd $RPM_BUILD_ROOT/%{modulefile_path_top}/%{compiler}
ln -s ../.modulerc-%{compiler}-%{bits}* .
popd
%endif
cat <<ENDCOREMODULE > ${RPM_BUILD_ROOT}%{modulefile_path}/%{version}
#%Module

# NOTE: This is an automatically-generated file!  (generated by the
# hdf5 rpm).  Any changes made here will be lost a) if the RPM is
# uninstalled, or b) if the RPM is upgraded or uninstalled.

proc ModulesHelp { } {
   puts stderr "This module adds hdf5 %{version} for %{compilerlong} to various paths"
}   
    
module-whatis   "Sets up hdf5 {version} for %{compilerlong} in your environment"

prepend-path PATH "%{localdir}/bin"
prepend-path LD_LIBRARY_PATH "%{localdir}/%{_lib}"
prepend-path LIBRARY_PATH "%{localdir}/%{_lib}"
prepend-path MANPATH "%{localdir}/share/man"
setenv HDF5_ROOT "%{localdir}"
setenv HDF5DIR "%{localdir}"
append-path -d { } LDFLAGS "-L%{localdir}/%{_lib}"
append-path -d { } INCLUDE "-I%{localdir}/include"
append-path CPATH "%{localdir}/include"
append-path -d { } FFLAGS "-I%{localdir}/include"
append-path -d { } FCFLAGS "-I%{localdir}/include"
append-path -d { } LOCAL_LDFLAGS "-L%{localdir}/%{_lib}"
append-path -d { } LOCAL_INCLUDE "-I%{localdir}/include"
append-path -d { } LOCAL_CFLAGS "-I%{localdir}/include"
append-path -d { } LOCAL_FFLAGS "-I%{localdir}/include"
append-path -d { } LOCAL_FCFLAGS "-I%{localdir}/include"
append-path -d { } LOCAL_CXXFLAGS "-I%{localdir}/include"
ENDCOREMODULE


setonemodule() {
mkdir -p ${RPM_BUILD_ROOT}%{modulefile_path}/$1
echo '#%Module' > ${RPM_BUILD_ROOT}%{modulefile_path}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-${1}-%{hdf5numversion}
if [ "%{compiler}" != "%{compilerlong}" -o "$1" != "$2"]; then
  echo "module-alias hdf5/%{compiler}/$2 hdf5/%{compilerlong}/$1" >> ${RPM_BUILD_ROOT}%{modulefile_path}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-${1}-%{hdf5numversion}
fi
%if "%{compiler}" != "%{compilershort}"
  echo "module-alias hdf5/%{compilershort}/$2 hdf5/%{compilerlong}/$1" >> ${RPM_BUILD_ROOT}%{modulefile_path}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-${1}-%{hdf5numversion}
  pushd $RPM_BUILD_ROOT/%{modulefile_path_top}/%{compilershort}
  ln -s ../%{compilerlong}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-${1}* .
  popd
%endif
if [ "$1" != "$2"]; then
  echo "module-alias hdf5/%{compilerlong}/$2 hdf5/%{compilerlong}/$1" >> ${RPM_BUILD_ROOT}%{modulefile_path}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-${1}-%{hdf5numversion}
fi
%if "%{compiler}" != "%{compilerlong}"
pushd $RPM_BUILD_ROOT/%{modulefile_path_top}/%{compiler}
ln -s ../%{compilerlong}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-${1}* .
popd
%endif
cat <<ENDOPENMPIMODULE > ${RPM_BUILD_ROOT}%{modulefile_path}/$1/%{version}
#%Module

# NOTE: This is an automatically-generated file!  (generated by the
# hdf5 rpm).  Any changes made here will be lost a) if the RPM is
# uninstalled, or b) if the RPM is upgraded or uninstalled.

proc ModulesHelp { } {
   puts stderr "This module adds hdf5 %{version} for %{compilerlong} $1 to various paths"
}   
    
module-whatis   "Sets up hdf5 {version} for %{compilerlong} $1 in your environment"

prepend-path PATH "$3/bin"
prepend-path LD_LIBRARY_PATH "$3/%{_lib}"
prepend-path LIBRARY_PATH "$3/%{_lib}"
prepend-path MANPATH "$3/share/man"
setenv HDF5_ROOT "$3"
setenv HDF5DIR "$3"
append-path -d { } LDFLAGS "-L$3/%{_lib}"
append-path -d { } INCLUDE "-I$3/include"
append-path CPATH "$3/include"
append-path -d { } FFLAGS "-I$3/include"
append-path -d { } FCFLAGS "-I$3/include"
append-path -d { } LOCAL_LDFLAGS "-L$3/%{_lib}"
append-path -d { } LOCAL_INCLUDE "-I$3/include"
append-path -d { } LOCAL_CFLAGS "-I$3/include"
append-path -d { } LOCAL_FFLAGS "-I$3/include"
append-path -d { } LOCAL_FCFLAGS "-I$3/include"
append-path -d { } LOCAL_CXXFLAGS "-I$3/include"
ENDOPENMPIMODULE
}
%if %{with_openmpi}
setonemodule openmpi-%{openmpiversion} openmpi %{localdiropenmpi} 
%endif
%if %{with mpt}
setonemodule mpt mpt %{localdirmpt}
%endif
%if %{with impi}
setonemodule intel-mpi intel-mpi %{localdirimpi}
%endif


%check
%if %{with tests}
. /etc/profile.d/modules.sh
export MODULEPATH=$MODULEPATH:/usr/local/share/Modules/modulefiles:/opt/share/Modules/modulefiles

# Kill the stack protection and fortify source stuff...it slows things down and here we only care about speed
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/-Wp,-D_FORTIFY_SOURCE=.//' -e 's/-fstack-protector-strong//' -e 's/-fstack-protector//' -e 's/-fstack-clash-protection//'`
%if !%{with debug}
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/-g//'`
%endif

CFLAGS="%{?cflags:%{cflags}}%{!?cflags:$RPM_OPT_FLAGS}"
CXXFLAGS="%{?cxxflags:%{cxxflags}}%{!?cxxflags:$RPM_OPT_FLAGS}"
FCFLAGS="%{?fcflags:%{fcflags}}%{!?fcflags:$RPM_OPT_FLAGS} -I%{_fmoddir}"
FFLAGS="%{?fcflags:%{fcflags}}%{!?fcflags:$RPM_OPT_FLAGS} -I%{_fmoddir}"

#Serial build
export CC=gcc
export CXX=g++
export F9X=gfortran

%{compilerbuildprep}
make -C build check
#These really don't work on builders
#for mpi in mpich2 openmpi
#do
#  module load $mpi-%{_arch}
#  make -C $mpi check
#  module purge
#done
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc COPYING MANIFEST README.txt release_docs/RELEASE.txt
%doc release_docs/HISTORY*.txt
%{localdir}/bin/gif2h5
%{localdir}/bin/h52gif
%{localdir}/bin/h5clear
%{localdir}/bin/h5copy
%{localdir}/bin/h5debug
%{localdir}/bin/h5diff
%{localdir}/bin/h5dump
%{localdir}/bin/h5format_convert
%{localdir}/bin/h5import
%{localdir}/bin/h5jam
%{localdir}/bin/h5ls
%{localdir}/bin/h5mkgrp
%{localdir}/bin/h5perf_serial
%{localdir}/bin/h5repack
%{localdir}/bin/h5repart
%{localdir}/bin/h5stat
%{localdir}/bin/h5unjam
%{localdir}/bin/h5watch
%{localdir}/%{_lib}/*.so.*
%dir %{modulefile_path_top}
%dir %{modulefile_path}
%{modulefile_path}/%{version}
%{modulefile_compiler_alias}
%if "%{compiler}" != "%{compilershort}"
%dir %{modulefile_path_top}/%{compilershort}
%{modulefile_path_top}/%{compilershort}/.modulerc-%{compiler}-%{bits}*
%endif
%if "%{compiler}" != "%{compilerlong}"
%dir %{modulefile_path_top}/%{compiler}
%{modulefile_path_top}/%{compiler}/.modulerc-%{compiler}-%{bits}*
%endif

%files devel
%defattr(-,root,root,-)
%{localdir}/bin/h5c++*
%{localdir}/bin/h5cc*
%{localdir}/bin/h5fc*
%{localdir}/bin/h5redeploy
%{localdir}/include/*.h
%{localdir}/%{_lib}/*.so
%{localdir}/%{_lib}/*.settings
%{localdir}/%{_lib}/finclude
%{localdir}/include/*.mod
%{localdir}/share/hdf5_examples/

%files static
%defattr(-,root,root,-)
%{localdir}/%{_lib}/*.a

%if %{with_mpich2}
%files mpich2
%defattr(-,root,root,-)
%doc COPYING MANIFEST README.txt release_docs/RELEASE.txt
%doc release_docs/HISTORY*.txt
%{_libdir}/mpich2/bin/gif2h5
%{_libdir}/mpich2/bin/h52gif
%{_libdir}/mpich2/bin/h5copy
%{_libdir}/mpich2/bin/h5debug
%{_libdir}/mpich2/bin/h5diff
%{_libdir}/mpich2/bin/h5dump
%{_libdir}/mpich2/bin/h5import
%{_libdir}/mpich2/bin/h5jam
%{_libdir}/mpich2/bin/h5ls
%{_libdir}/mpich2/bin/h5mkgrp
%{_libdir}/mpich2/bin/h5redeploy
%{_libdir}/mpich2/bin/h5repack
%{_libdir}/mpich2/bin/h5perf
%{_libdir}/mpich2/bin/h5perf_serial
%{_libdir}/mpich2/bin/h5repart
%{_libdir}/mpich2/bin/h5stat
%{_libdir}/mpich2/bin/h5unjam
%{_libdir}/mpich2/bin/ph5diff
%{_libdir}/mpich2/%{_lib}/*.so.*

%files mpich2-devel
%defattr(-,root,root,-)
%{_includedir}/mpich2-%{_arch}
%{_libdir}/mpich2/bin/h5pcc
%{_libdir}/mpich2/bin/h5pfc
%{_libdir}/mpich2/%{_lib}/lib*.so
#{_libdir}/mpich2/lib/lib*.settings

%files mpich2-static
%defattr(-,root,root,-)
%{_libdir}/mpich2/lib/*.a
%endif

%if %{with_openmpi}
%files openmpi%{openmpinumversion}
%defattr(-,root,root,-)
%doc COPYING MANIFEST README.txt release_docs/RELEASE.txt
%doc release_docs/HISTORY*.txt
%{localdiropenmpi}/bin/gif2h5
%{localdiropenmpi}/bin/h52gif
%{localdiropenmpi}/bin/h5clear
%{localdiropenmpi}/bin/h5copy
%{localdiropenmpi}/bin/h5debug
%{localdiropenmpi}/bin/h5diff
%{localdiropenmpi}/bin/h5dump
%{localdiropenmpi}/bin/h5format_convert
%{localdiropenmpi}/bin/h5import
%{localdiropenmpi}/bin/h5jam
%{localdiropenmpi}/bin/h5ls
%{localdiropenmpi}/bin/h5mkgrp
%{localdiropenmpi}/bin/h5perf*
%{localdiropenmpi}/bin/h5redeploy
%{localdiropenmpi}/bin/h5repack
%{localdiropenmpi}/bin/h5repart
%{localdiropenmpi}/bin/h5stat
%{localdiropenmpi}/bin/h5unjam
%{localdiropenmpi}/bin/h5watch
%{localdiropenmpi}/bin/ph5diff
%{localdiropenmpi}/%{_lib}/*.so.*
%dir %{modulefile_path_top}
%dir %{modulefile_path}
%dir %{modulefile_path}/openmpi-%{openmpiversion}
%{modulefile_path}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-openmpi-%{openmpiversion}*
%{modulefile_path}/openmpi-%{openmpiversion}/%{version}
%if "%{compiler}" != "%{compilershort}"
%dir %{modulefile_path_top}/%{compilershort}
%{modulefile_path_top}/%{compilershort}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-openmpi*
%endif
%if "%{compiler}" != "%{compilerlong}"
%dir %{modulefile_path_top}/%{compiler}
%{modulefile_path_top}/%{compiler}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-openmpi*
%endif

%files openmpi%{openmpinumversion}-devel
%defattr(-,root,root,-)
%{localdiropenmpi}/include
%{localdiropenmpi}/bin/h5pcc
%{localdiropenmpi}/bin/h5pfc
%{localdiropenmpi}/%{_lib}/lib*.so
%{localdiropenmpi}/%{_lib}/lib*.settings
%{localdiropenmpi}/%{_lib}/finclude
%{localdiropenmpi}/share/hdf5_examples/

%files openmpi%{openmpinumversion}-static
%defattr(-,root,root,-)
%{localdiropenmpi}/%{_lib}/lib*.a
%endif

%if %{with mpt}
%files mpt
%defattr(-,root,root,-)
%doc COPYING MANIFEST README.txt release_docs/RELEASE.txt
%doc release_docs/HISTORY*.txt
%{localdirmpt}/bin/gif2h5
%{localdirmpt}/bin/h52gif
%{localdirmpt}/bin/h5clear
%{localdirmpt}/bin/h5copy
%{localdirmpt}/bin/h5debug
%{localdirmpt}/bin/h5diff
%{localdirmpt}/bin/h5dump
%{localdirmpt}/bin/h5format_convert
%{localdirmpt}/bin/h5import
%{localdirmpt}/bin/h5jam
%{localdirmpt}/bin/h5ls
%{localdirmpt}/bin/h5mkgrp
%{localdirmpt}/bin/h5perf*
%{localdirmpt}/bin/h5redeploy
%{localdirmpt}/bin/h5repack
%{localdirmpt}/bin/h5repart
%{localdirmpt}/bin/h5stat
%{localdirmpt}/bin/h5unjam
%{localdirmpt}/bin/h5watch
%{localdirmpt}/bin/ph5diff
%{localdirmpt}/%{_lib}/*.so.*
%dir %{modulefile_path_top}
%dir %{modulefile_path}
%dir %{modulefile_path}/mpt
%{modulefile_path}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-mpt*
%{modulefile_path}/mpt/%{version}
%if "%{compiler}" != "%{compilershort}"
%dir %{modulefile_path_top}/%{compilershort}
%{modulefile_path_top}/%{compilershort}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-mpt*
%endif
%if "%{compiler}" != "%{compilerlong}"
%dir %{modulefile_path_top}/%{compiler}
%{modulefile_path_top}/%{compiler}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-mpt*
%endif

%files mpt-devel
%defattr(-,root,root,-)
%{localdirmpt}/include
%{localdirmpt}/bin/h5pcc
%{localdirmpt}/bin/h5pfc
%{localdirmpt}/%{_lib}/lib*.so
%{localdirmpt}/%{_lib}/lib*.settings
%{localdirmpt}/%{_lib}/finclude
%{localdirmpt}/share/hdf5_examples/

%files mpt-static
%defattr(-,root,root,-)
%{localdirmpt}/%{_lib}/lib*.a
%endif

%if %{with impi}
%files impi
%defattr(-,root,root,-)
%doc COPYING MANIFEST README.txt release_docs/RELEASE.txt
%doc release_docs/HISTORY*.txt
%{localdirimpi}/bin/gif2h5
%{localdirimpi}/bin/h52gif
%{localdirimpi}/bin/h5clear
%{localdirimpi}/bin/h5copy
%{localdirimpi}/bin/h5debug
%{localdirimpi}/bin/h5diff
%{localdirimpi}/bin/h5dump
%{localdirimpi}/bin/h5format_convert
%{localdirimpi}/bin/h5import
%{localdirimpi}/bin/h5jam
%{localdirimpi}/bin/h5ls
%{localdirimpi}/bin/h5mkgrp
%{localdirimpi}/bin/h5perf*
%{localdirimpi}/bin/h5redeploy
%{localdirimpi}/bin/h5repack
%{localdirimpi}/bin/h5repart
%{localdirimpi}/bin/h5stat
%{localdirimpi}/bin/h5unjam
%{localdirimpi}/bin/h5watch
%{localdirimpi}/bin/ph5diff
%{localdirimpi}/%{_lib}/*.so.*
%dir %{modulefile_path_top}
%dir %{modulefile_path}
%dir %{modulefile_path}/intel-mpi
%{modulefile_path}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-intel-mpi*
%{modulefile_path}/intel-mpi/%{version}
%if "%{compiler}" != "%{compilershort}"
%dir %{modulefile_path_top}/%{compilershort}
%{modulefile_path_top}/%{compilershort}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-intel-mpi*
%endif
%if "%{compiler}" != "%{compilerlong}"
%dir %{modulefile_path_top}/%{compiler}
%{modulefile_path_top}/%{compiler}/.modulerc-%{compiler}-%{bits}-%{compilerversionnum}-intel-mpi*
%endif

%files impi-devel
%defattr(-,root,root,-)
%{localdirimpi}/include
%{localdirimpi}/bin/h5pcc
%{localdirimpi}/bin/h5pfc
%{localdirimpi}/%{_lib}/lib*.so
%{localdirimpi}/%{_lib}/lib*.settings
%{localdirimpi}/%{_lib}/finclude
%{localdirimpi}/share/hdf5_examples/

%files impi-static
%defattr(-,root,root,-)
%{localdirimpi}/%{_lib}/lib*.a
%endif

%changelog
* Sat Jan 14 2012 Josko Plazonic <plazonic@math.princeton.edu>
- modify the build to use multiple compilers and env modules
  for loading
- patch configure to fix intel mpi builds and ld flag to fix
  build-id issues when using intel
- added gpfs support

* Sat Jan 7 2012 Orion Poplawski <orion@cora.nwra.com> 1.8.8-6
- Enable Fortran 2003 support (bug 772387)

* Wed Dec 21 2011 Dan Horák <dan[at]danny.cz> 1.8.8-5
- reintroduce the tstlite patch for ppc64 and s390x

* Thu Dec 01 2011 Caolán McNamara <caolanm@redhat.com> 1.8.8-4
- Related: rhbz#758334 hdf5 doesn't build on ppc64

* Fri Nov 25 2011 Orion Poplawski <orion@cora.nwra.com> 1.8.8-3
- Enable static MPI builds

* Wed Nov 16 2011 Orion Poplawski <orion@cora.nwra.com> 1.8.8-2
- Add rpm macro %%{_hdf5_version} for convenience

* Tue Nov 15 2011 Orion Poplawski <orion@cora.nwra.com> 1.8.8-1
- Update to 1.8.8
- Drop tstlite patch
- Add patch to avoid setting LD_LIBRARY_PATH

* Wed Jun 01 2011 Karsten Hopp <karsten@redhat.com> 1.8.7-2
- drop ppc64 longdouble patch, not required anymore

* Tue May 17 2011 Orion Poplawski <orion@cora.nwra.com> 1.8.7-1
- Update to 1.8.7

* Tue Mar 29 2011 Deji Akingunola <dakingun@gmail.com> - 1.8.6-2
- Rebuild for mpich2 soname bump

* Fri Feb 18 2011 Orion Poplawski <orion@cora.nwra.com> 1.8.6-1
- Update to 1.8.6-1
- Update tstlite patch - not fixed yet

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.8.5.patch1-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Feb 6 2011 Orion Poplawski <orion@cora.nwra.com> 1.8.5.patch1-7
- Add Requires: zlib-devel to hdf5-devel

* Sun Dec 12 2010 Dan Horák <dan[at]danny.cz> 1.8.5.patch1-6
- fully conditionalize MPI support

* Wed Dec 8 2010 Orion Poplawski <orion@cora.nwra.com> 1.8.5.patch1-5
- Add EL6 compatibility - no mpich2 on ppc64

* Wed Oct 27 2010 Orion Poplawski <orion@cora.nwra.com> 1.8.5.patch1-4
- Really fixup all permissions

* Wed Oct 27 2010 Orion Poplawski <orion@cora.nwra.com> 1.8.5.patch1-3
- Add docs to the mpi packages
- Fixup example source file permissions

* Tue Oct 26 2010 Orion Poplawski <orion@cora.nwra.com> 1.8.5.patch1-2
- Build parallel hdf5 packages for mpich2 and openmpi
- Rework multiarch support and drop multiarch patch

* Tue Sep 7 2010 Orion Poplawski <orion@cora.nwra.com> 1.8.5.patch1-1
- Update to 1.8.5-patch1

* Wed Jun 23 2010 Orion Poplawski <orion@cora.nwra.com> 1.8.5-4
- Re-add rebased tstlite patch - not fixed yet

* Wed Jun 23 2010 Orion Poplawski <orion@cora.nwra.com> 1.8.5-3
- Update longdouble patch for 1.8.5

* Wed Jun 23 2010 Orion Poplawski <orion@cora.nwra.com> 1.8.5-2
- Re-add longdouble patch on ppc64 for EPEL builds

* Mon Jun 21 2010 Orion Poplawski <orion@cora.nwra.com> 1.8.5-1
- Update to 1.8.5
- Drop patches fixed upstream

* Mon Mar 1 2010 Orion Poplawski <orion@cora.nwra.com> 1.8.4.patch1-1
- Update to 1.8.4-patch1

* Wed Jan 6 2010 Orion Poplawski <orion@cora.nwra.com> 1.8.4-1
- Update to 1.8.4
- Must compile with -O0 due to gcc-4.4 incompatability
- No longer need -fno-strict-aliasing

* Thu Oct 1 2009 Orion Poplawski <orion@cora.nwra.com> 1.8.3-3.snap12
- Update to 1.8.3-snap12
- Update signal patch
- Drop detect and filter-as-option patch fixed upstream
- Drop ppc only patch
- Add patch to skip tstlite test for now, problem reported upstream
- Fixup some source file permissions

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.8.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Jun 2 2009 Orion Poplawski <orion@cora.nwra.com> 1.8.3-1
- Update to 1.8.3
- Update signal and detect patches
- Drop open patch fixed upstream

* Sat Apr 18 2009 Karsten Hopp <karsten@redhat.com> 1.8.2-1.1
- fix s390x builds, s390x is 64bit, s390 is 32bit

* Mon Feb 23 2009 Orion Poplawski <orion@cora.nwra.com> 1.8.2-1
- Update to 1.8.2
- Add patch to compile H5detect without optimization - make detection
  of datatype characteristics more robust - esp. long double
- Update signal patch
- Drop destdir patch fixed upstream
- Drop scaleoffset patch
- Re-add -fno-strict-aliasing
- Keep settings file needed for -showconfig (bug #481032)
- Wrapper script needs to pass arguments (bug #481032)

* Wed Oct 8 2008 Orion Poplawski <orion@cora.nwra.com> 1.8.1-3
- Add sparc64 to 64-bit conditionals

* Fri Sep 26 2008 Orion Poplawski <orion@cora.nwra.com> 1.8.1-2
- Add patch to filter -little as option used on sh arch (#464052)

* Thu Jun 5 2008 Orion Poplawski <orion@cora.nwra.com> 1.8.1-1
- Update to 1.8.1

* Tue May 27 2008 Orion Poplawski <orion@cora.nwra.com> 1.8.1-0.rc1.1
- Update to 1.8.1-rc1

* Tue May 13 2008 Orion Poplawski <orion@cora.nwra.com> 1.8.0.snap5-2
- Use new %%{_fmoddir} macro
- Re-enable ppc64, disable failing tests.  Failing tests are for
  experimental long double support.

* Mon May 5 2008 Orion Poplawski <orion@cora.nwra.com> 1.8.0.snap5-1
- Update to 1.8.0-snap5
- Remove --enable-threadsafe, incompatible with --enable-cxx and
  --enable-fortran
- ExcludeArch ppc64 until we can get it to build (bug #445423)

* Tue Mar 4 2008 Orion Poplawski <orion@cora.nwra.com> 1.8.0-2
- Remove failing test for now

* Fri Feb 29 2008 Orion Poplawski <orion@cora.nwra.com> 1.8.0-1
- Update to 1.8.0, drop upstreamed patches
- Update signal patch
- Move static libraries into -static sub-package
- Make -devel multiarch (bug #341501)

* Wed Feb  6 2008 Orion Poplawski <orion@cora.nwra.com> 1.6.6-7
- Add patch to fix strict-aliasing
- Disable production mode to enable debuginfo

* Tue Feb  5 2008 Orion Poplawski <orion@cora.nwra.com> 1.6.6-6
- Add patch to fix calling free() in H5PropList.cpp

* Tue Feb  5 2008 Orion Poplawski <orion@cora.nwra.com> 1.6.6-5
- Add patch to support s390 (bug #431510)

* Mon Jan  7 2008 Orion Poplawski <orion@cora.nwra.com> 1.6.6-4
- Add patches to support sparc (bug #427651)

* Tue Dec  4 2007 Orion Poplawski <orion@cora.nwra.com> 1.6.6-3
- Rebuild against new openssl

* Fri Nov 23 2007 Orion Poplawski <orion@cora.nwra.com> 1.6.6-2
- Add patch to build on alpha (bug #396391)

* Wed Oct 17 2007 Orion Poplawski <orion@cora.nwra.com> 1.6.6-1
- Update to 1.6.6, drop upstreamed patches
- Explicitly set compilers

* Fri Aug 24 2007 Orion Poplawski <orion@cora.nwra.com> 1.6.5-9
- Update license tag to BSD
- Rebuild for BuildID

* Wed Aug  8 2007 Orion Poplawski <orion@cora.nwra.com> 1.6.5-8
- Fix memset typo
- Pass mode to open with O_CREAT

* Mon Feb 12 2007 Orion Poplawski <orion@cora.nwra.com> 1.6.5-7
- New project URL
- Add patch to use POSIX sort key option
- Remove useless and multilib conflicting Makefiles from html docs
  (bug #228365)
- Make hdf5-devel own %%{_docdir}/%%{name}

* Tue Aug 29 2006 Orion Poplawski <orion@cora.nwra.com> 1.6.5-6
- Rebuild for FC6

* Wed Mar 15 2006 Orion Poplawski <orion@cora.nwra.com> 1.6.5-5
- Change rpath patch to not need autoconf
- Add patch for libtool on x86_64
- Fix shared lib permissions

* Mon Mar 13 2006 Orion Poplawski <orion@cora.nwra.com> 1.6.5-4
- Add patch to avoid HDF setting the compiler flags

* Mon Feb 13 2006 Orion Poplawski <orion@cora.nwra.com> 1.6.5-3
- Rebuild for gcc/glibc changes

* Wed Dec 21 2005 Orion Poplawski <orion@cora.nwra.com> 1.6.5-2
- Don't ship h5perf with missing library

* Wed Dec 21 2005 Orion Poplawski <orion@cora.nwra.com> 1.6.5-1
- Update to 1.6.5

* Wed Dec 21 2005 Orion Poplawski <orion@cora.nwra.com> 1.6.4-9
- Rebuild

* Wed Nov 30 2005 Orion Poplawski <orion@cora.nwra.com> 1.6.4-8
- Package fortran files properly
- Move compiler wrappers to devel

* Fri Nov 18 2005 Orion Poplawski <orion@cora.nwra.com> 1.6.4-7
- Add patch for fortran compilation on ppc

* Wed Nov 16 2005 Orion Poplawski <orion@cora.nwra.com> 1.6.4-6
- Bump for new openssl

* Tue Sep 20 2005 Orion Poplawski <orion@cora.nwra.com> 1.6.4-5
- Enable fortran since the gcc bug is now fixed

* Tue Jul 05 2005 Orion Poplawski <orion@cora.nwra.com> 1.6.4-4
- Make example scripts executable

* Wed Jul 01 2005 Orion Poplawski <orion@cora.nwra.com> 1.6.4-3
- Add --enable-threads --with-pthreads to configure
- Add %%check
- Add some %%docs
- Use %%makeinstall
- Add patch to fix test for h5repack
- Add patch to fix h5diff_attr.c

* Mon Jun 27 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.6.4-2
- remove szip from spec, since szip license doesn't meet Fedora standards

* Sun Apr 3 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.6.4-1
- inital package for Fedora Extras
